aboutsummaryrefslogtreecommitdiffstats
path: root/gcc-4.9/gcc/lock-and-run.sh
diff options
context:
space:
mode:
authorBen Cheng <bccheng@google.com>2014-03-25 22:37:19 -0700
committerBen Cheng <bccheng@google.com>2014-03-25 22:37:19 -0700
commit1bc5aee63eb72b341f506ad058502cd0361f0d10 (patch)
treec607e8252f3405424ff15bc2d00aa38dadbb2518 /gcc-4.9/gcc/lock-and-run.sh
parent283a0bf58fcf333c58a2a92c3ebbc41fb9eb1fdb (diff)
downloadtoolchain_gcc-1bc5aee63eb72b341f506ad058502cd0361f0d10.tar.gz
toolchain_gcc-1bc5aee63eb72b341f506ad058502cd0361f0d10.tar.bz2
toolchain_gcc-1bc5aee63eb72b341f506ad058502cd0361f0d10.zip
Initial checkin of GCC 4.9.0 from trunk (r208799).
Change-Id: I48a3c08bb98542aa215912a75f03c0890e497dba
Diffstat (limited to 'gcc-4.9/gcc/lock-and-run.sh')
-rw-r--r--gcc-4.9/gcc/lock-and-run.sh34
1 files changed, 34 insertions, 0 deletions
diff --git a/gcc-4.9/gcc/lock-and-run.sh b/gcc-4.9/gcc/lock-and-run.sh
new file mode 100644
index 000000000..3a6a84c25
--- /dev/null
+++ b/gcc-4.9/gcc/lock-and-run.sh
@@ -0,0 +1,34 @@
+#! /bin/sh
+# Shell-based mutex using mkdir.
+
+lockdir="$1" prog="$2"; shift 2 || exit 1
+
+# Remember when we started trying to acquire the lock.
+count=0
+touch lock-stamp.$$
+
+trap 'rm -r "$lockdir" lock-stamp.$$' 0
+
+until mkdir "$lockdir" 2>/dev/null; do
+ # Say something periodically so the user knows what's up.
+ if [ `expr $count % 30` = 0 ]; then
+ # Reset if the lock has been renewed.
+ if [ -n "`find \"$lockdir\" -newer lock-stamp.$$`" ]; then
+ touch lock-stamp.$$
+ count=1
+ # Steal the lock after 5 minutes.
+ elif [ $count = 300 ]; then
+ echo removing stale $lockdir >&2
+ rm -r "$lockdir"
+ else
+ echo waiting to acquire $lockdir >&2
+ fi
+ fi
+ sleep 1
+ count=`expr $count + 1`
+done
+
+echo $prog "$@"
+$prog "$@"
+
+# The trap runs on exit.